<?php

include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Produit.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Venteprod.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Ventedeclidisp.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Declidispdesc.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../client/plugins/combinaison/Combinaison.class.php");


class Entrepot extends PluginsClassiques {

	var $id;
	var $nom;
	var $entrepot_type;
	var $delai_livraison;
	var $delai_reappro;	
	var $entrepot_qte_max; 
	var $delai_defaut;
	var $table ="entrepot";
	var $bddvars = array ("id", "nom", "entrepot_type", "delai_livraison", "delai_reappro");
	
	
	function Entrepot(){
		$this->PluginsClassiques("entrepot");	
		$this->entrepot_qte_max =1000;
		$this->delai_defaut =2;	
	}
	
	function init(){
		$query_entrepot = "CREATE TABLE `entrepot` (
							`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
							`nom` TEXT ,
							`entrepot_type` INT ,
							`delai_livraison` INT ,
							`delai_reappro` INT 
							);";
		$resul_entrepot = mysql_query($query_entrepot, $this->link);
		
		$chargedefaut = new Entrepot();
		$chargedefaut->nom = 'Nommer un fournisseur';
		$chargedefaut->add();		
	}
			
	function charger($id){
		return $this->getVars("select * from $this->table where id=\"$id\"");
	} 
	
	function type_stock($prod){
		
		if ($prod->perso >0){		
		$query_entrepot2 = "select * from $this->table where id=\"$prod->perso\"";		
		$resul_entrepot2 = mysql_query($query_entrepot2);
		
			while($entrepot = mysql_fetch_object($resul_entrepot2)){
			$nom_fourn=$entrepot->nom;
			$delivr = $entrepot->delai_livraison;
			$delreappro = $entrepot->delai_reappro;
			
				if ($entrepot->entrepot_type==0) {	
					$type_stock0 = 0;
					$type_stock1 = 'Unique';		
				}
					
				if ($entrepot->entrepot_type==1) {
					$type_stock0 = 1;
					$type_stock1 = 'Variable';
				}
					
				if ($entrepot->entrepot_type==2) {
					$type_stock0 = 2;
					$type_stock1 = 'Illimit&eacute;';		
				}
			}		
		}
		
		else {
		$type_stock0 = 0;
		$type_stock1 = 'Unique';
		$nom_fourn = '---';
		$delivr = $this->delai_defaut;
		$delreappro = 0;
		}
	
		$tabtype = array();
		$tabtype[0] =$type_stock0;
		$tabtype[1] =$type_stock1;	
		$tabtype[2] =$nom_fourn;
		$tabtype[3] =$delivr;
		$tabtype[4] =$delreappro;
		
		return $tabtype;		
	}	
	
	
	function etat_stock($type, $stock){
		
	if ($type==0) {	
		if ($stock >0) {
		$etat_stock0= 3;
		$etat_stock1= 'Stock approvisionn&eacute;';			
		}
		else {
		$etat_stock0= 0;
		$etat_stock1='Rupture de stock';
		}		
	}	
	if ($type==1) {
		if ($stock >0) {
		$etat_stock0= 3;
		$etat_stock1= 'Stock approvisionn&eacute;';			
		}
		else {
		$etat_stock0= 1;
		$etat_stock1='Approvisionnement';
		}
	}
	if ($type==2) {
		$etat_stock0= 3;
		$etat_stock1= 'Stock approvisionn&eacute;';		
	}	
		
	$tabetat[0]=$etat_stock0;	
	$tabetat[1]=$etat_stock1;		
	return $tabetat;
	}
	
		
	function qte_prod_commande($ref){ 
	
	$produit = new Produit();
	$commande = new Commande();
	$venteprod = new Venteprod();
	$ventedeclidisp = new Ventedeclidisp();
	$declidispdesc = new Declidispdesc();
	$tabcode = array();
	$qte="";
	$query_qte = "select * 
		from $commande->table left join $venteprod->table
		on $commande->table.id=$venteprod->table.commande 
		where $venteprod->table.ref='" . $ref . "'
		and $commande->table.statut < '4'";   	
		$resul_qte = mysql_query($query_qte);		

		while($row = mysql_fetch_object($resul_qte)){
			$ventid=$row->id;
			
			$query_qte2 = "select * 
			from $ventedeclidisp->table 
			where $ventedeclidisp->table.venteprod='".$ventid."'";   	
			$resul_qte2 = mysql_query($query_qte2, $ventedeclidisp->link);		
			$n=0;
			$code="";			
			$nbre = mysql_num_rows($resul_qte2);
				
			if ($nbre>0){
				while($row2 = mysql_fetch_object($resul_qte2)){
				$n++;
				$declidispdesc = new Declidispdesc();
				$declidispdesc->charger($row2->declidisp);
				($n>1) ? $code .= " - ".$declidispdesc->titre : $code = $declidispdesc->titre;
				}
			}
			($code !="") ? $tabcode[$code] += $row->quantite : $tabcode['---'] = $row->quantite;		
		}
	return $tabcode;
	}
	
	
	function stock_delai($prodref) {
	
		$prod=new Produit();
		$prod->charger($prodref);
		$declidispdesc = new Declidispdesc();
		$tabcombi=array();
		$tab_decreq=array();
		$stock="";
		$delivr="";
		
		$typestock = $this->type_stock($prod);
	
		$combi = new Combinaison();		
				
		$query_boucle = "select * from $combi->table
					where ref = '".$prodref."'
					and actif='1'
					order by $combi->table.code";
		$resul_boucle = mysql_query($query_boucle, $combi->link);				
		
				
		while($combi = mysql_fetch_object($resul_boucle)){				
		$tabcombi[$combi->code] = $combi->stock;							
		}		
			
		//1- si le produit a des combinaisons
		if (count($tabcombi)!==0) {
		
			foreach ($_REQUEST as $key => $valeur) {
				if(strstr($key, "declinaison")){
				$tab_decreq[] = $valeur;				
				}
			}
			//1-a si aucun paramtre d'url ne prcise quelle combinaison
			if (count($tab_decreq)==0){	
										
				$stock=current($tabcombi);
					
				if ($typestock[0] ==0) {
					
					foreach($tabcombi as $k=>$v){							
					if($v ==!0 && $stock==0) $stock= $v;
					}		
					
					if ($stock <=0){
					$stock ='Rupture de stock';
					$delivr='Produit indisponible';
					}
					
					else $delivr = $typestock[3];
				}
				
				if ($typestock[0] ==1 && $stock<=0) {
				$stock ='R&eacute;approvisionnement en cours';
				$delivr= $typestock[3]+$typestock[4].' jours';
				}
				if ($typestock[0] ==1 && $stock>0) {
				$delivr = $typestock[3];
				}
				
				if ($typestock[0] ==2) {
				$stock ='En stock';	
				$delivr=$typestock[3];	
				}		
			}
			// 1-b si des paramtres d'url prcisent quelle combinaison
			else {
				
				$code="";
				$tabfinal = array();
				foreach ($tabcombi as $k=>$v){
				$combi2 = new Combinaison();
				$stock = $v;		
				$tabtemp = explode(' - ', $k);
				$nb_declinaison = count($tabtemp);
					
				$i= -1;
				$tabdisp = $combi2->recursi($tabtemp, $stock, $nb_declinaison, $i, $typestock[0]);		
				$tabfinal = $combi2->array_merge_recursive_distinct($tabfinal, $tabdisp);				
				}
				//Pour chaque paramtre d'url : 
				foreach ($tab_decreq as $v){
				
					if (is_array($tabfinal[$v])){			
					$tabfinal = $tabfinal[$v];
					}
					
					else {
						if (array_key_exists ($v, $tabfinal)){
						$stock = $tabfinal[$v];
						}
						
						else {
							$tabcle = array_keys($tabfinal);
							if (is_array($tabfinal[$tabcle[0]])){
							$tabfinal = $tabfinal[$tabcle[0]];
							}
							else {
							$stock = $tabfinal[$tabcle[0]];
							}			
						}			
					}		
				}						
							
				if ($typestock[0] ==0 && $stock<=0) {
				$stock ='Rupture de stock';
				$delivr = 'Produit indisponible';
				}
				if ($typestock[0] ==0 && $stock>0) {
				$delivr = $typestock[3];
				}
				
				if ($typestock[0] ==1 && $stock<=0){
				$stock ='R&eacute;approvisionnement en cours';
				$delivr= $typestock[3]+$typestock[4];
				}
				if ($typestock[0] ==1 && $stock>0) {
				$delivr = $typestock[3];
				}
				
				if ($typestock[0] ==2) {
				$stock ='En stock';		
				$delivr = $typestock[3];
				}		
			}
		}
		
		//2- Si ce produit n'a pas de combinaison	
		else {	
			
			$stock = $prod->stock;
			
			if ($typestock[0] ==0 && $prod->stock<=0) {
			$stock ='Rupture de stock';
			$delivr = 'Produit indisponible';
			}
			if ($typestock[0] ==0 && $prod->stock>0) {
			$delivr = $typestock[3];
			}
			
			if ($typestock[0] ==1 && $prod->stock<=0){
			$stock ='R&eacute;approvisionnement en cours';
			$delivr= $typestock[3]+$typestock[4];
			}
			if ($typestock[0] ==1 && $prod->stock>0) {
			$delivr = $typestock[3];
			}
			
			if ($typestock[0] ==2) {
			$stock ='En stock';		
			$delivr = $typestock[3];
			}		
		}	
	
		$tabfinal=array();
		$tabfinal['stock']=$stock;
		$tabfinal['delivr']=$delivr;
		return $tabfinal;
	}
	
	
	function boucle($texte, $args){
	
		$search ="";
		$res="";
		$prodref ="";
		$delivr="";
		$stock="";
		$tabstock_delai=array();
		
		$prodref = lireTag($args, "produit");
		
		//sur produit.html
		if ($prodref !=="") {
		
		$tabstock_delai = $this->stock_delai($prodref);
		$stock = $tabstock_delai['stock'];
		$delivr = $tabstock_delai['delivr'];
		
		}
		
		//sur panier.html
		else {
		
			if(! $_SESSION['navig']->panier->nbart) return;
						
			for($i=0; $i<$_SESSION['navig']->panier->nbart; $i++){
			$tabstock_delai = $this->stock_delai($_SESSION['navig']->panier->tabarticle[$i]->produit->ref);				
			if ($delivr < $tabstock_delai['delivr']) $delivr=$tabstock_delai['delivr'];		
			}
		}
		
		$temp = str_replace("#ENTREPOT_STOCK", "$stock", $texte);	
		$temp = str_replace("#DELIVR", "$delivr", $temp);	
	
		if(trim($temp) !="") $res .= $temp;	

	return $res; 
	}
	
	function destroy(){
	$query_entrepot = "DROP TABLE `entrepot`";
	$resul_entrepot = mysql_query($query_entrepot, $this->link);
	
	$prod = new Produit();
	$query_entrepot2 = "UPDATE $prod->table SET perso=0";
	$resul_entrepot2 = mysql_query($query_entrepot2, $prod->link);
	}
	
}
?>